#include <bits/stdc++.h>

using namespace std;

typedef unsigned long long int n_t;

int main()
{
    ios_base::sync_with_stdio(false);

    int test_cases_no;
    cin >> test_cases_no;

    vector<int> queries(test_cases_no);
    for (int i = 0; i < queries.size(); ++i)
        cin >> queries[i];

    auto max_query = 0;
    for (auto& query : queries)
        max_query = max(max_query, query);

    vector<n_t> counts(max_query + 1);

    auto a_bound = static_cast<int>(pow(max_query, 1.0 / 3.0));

    for (int a = 1; a <= a_bound; ++a) {
        auto tmp = static_cast<double>(max_query) / a;
        auto b_bound = static_cast<int>(sqrt(tmp));

        for (int b = a + 1; b <= b_bound; ++b) {
            for (int c = b + 1; ; ++c) {
                auto volume = a * b * c;
                if (volume > max_query)
                    break;
                ++counts[volume];
            }
        }
    }

    for (int i = 1; i < counts.size(); ++i)
        counts[i] = counts[i] + counts[i - 1];

    for (auto& query : queries)
        cout << counts[query] << endl;

    return 0;
}
